local addonName, L = ...;

local gameModeDropDown =
	{		
		["title"] = L["GAMEMODE_DROPDOWN_TITLE"],
			[1] = {
				["text"] = L["GAMEMODE_DROPDOWN_1V1_TEXT"],
				["value"] = 1,
			},
			[2] = {
				["text"] = L["GAMEMODE_DROPDOWN_2V2_TEXT"],
				["value"] = 2,
			},
			[3] = {
				["text"] = L["GAMEMODE_DROPDOWN_3V3_TEXT"],
				["value"] = 3,
			},
	};

local timeLimitMinutesDropDown = 
	{		
		["title"] = L["TIMELIMIT_DROPDOWN_MINUTES_TITLE"],
			[1] = {
				["text"] = "00",
				["value"] = 0,
			},
			[2] = {
				["text"] = "05",
				["value"] = 5,
			},
			[3] = {
				["text"] = "10",
				["value"] = 10,
			},
			[4] = {
				["text"] = "15",
				["value"] = 15,
			},
			[5] = {
				["text"] = "20",
				["value"] = 20,
			},
			[6] = {
				["text"] = "25",
				["value"] = 25,
			},
	};
	
local timeLimitSecondsDropDown = 
	{		
		["title"] = L["TIMELIMIT_DROPDOWN_SECONDS_TITLE"],
			[1] = {
				["text"] = "00",
				["value"] = 0,
			},
			[2] = {
				["text"] = "05",
				["value"] = 5,
			},
			[3] = {
				["text"] = "10",
				["value"] = 10,
			},
			[4] = {
				["text"] = "15",
				["value"] = 15,
			},
			[5] = {
				["text"] = "20",
				["value"] = 20,
			},
			[6] = {
				["text"] = "25",
				["value"] = 25,
			},
			[7] = {
				["text"] = "30",
				["value"] = 30,
			},
			[8] = {
				["text"] = "35",
				["value"] = 35,
			},
			[9] = {
				["text"] = "40",
				["value"] = 40,
			},
			[10] = {
				["text"] = "45",
				["value"] = 45,
			},
			[11] = {
				["text"] = "50",
				["value"] = 50,
			},
			[12] = {
				["text"] = "55",
				["value"] = 55,
			},
	};		

local broadCastChannelDropDown =
	{		
		["title"] = L["COUNTDOWN_BROADCAST_TO_CAHNNEL_DROPDOWN_TITLE"],
			[1] = {
				["text"] = L["SAY"],
				["value"] = "SAY",
			},
			[2] = {
				["text"] = L["YELL"],
				["value"] = "YELL",
			},
			[3] = {
				["text"] = L["PARTY"],
				["value"] = "PARTY",
			},
			[4] = {
				["text"] = L["GUILD"],
				["value"] = "GUILD",
			},
			[5] = {
				["text"] = L["OFFICER"],
				["value"] = "OFFICER",
			},
			[6] = {
				["text"] = L["RAID"],
				["value"] = "RAID",
			},
			[7] = {
				["text"] = L["RAID_WARNING"],
				["value"] = "RAID_WARNING",
			},
			[8] = {
				["text"] = L["INSTANCE_CHAT"],
				["value"] = "INSTANCE_CHAT",
			},
	};
	
local countDownTimeDropDown =
	{		
		["title"] = L["COUNTDOWN_TIME_DROPDOWN_TITLE"],
			[1] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 5),
				["value"] = 5,
			},
			[2] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 10),
				["value"] = 10,
			},
			[3] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 15),
				["value"] = 15,
			},
			[4] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 20),
				["value"] = 20,
			},
			[5] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 25),
				["value"] = 25,
			},
			[6] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 30),
				["value"] = 30,
			},
			[7] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 35),
				["value"] = 35,
			},
			[8] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 40),
				["value"] = 40,
			},
			[9] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 45),
				["value"] = 45,
			},
			[10] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 50),
				["value"] = 50,
			},
			[11] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 55),
				["value"] = 55,
			},
			[12] = {
				["text"] = string.format(L["COUNTDOWN_TIME_DROPDOWN_TEXT"], 60),
				["value"] = 60,
			},
	};	
	
function ALSpec_Options:Initialise()
	-- Set up option panel:
	ALSpec_OptionsTitle:SetText(L["ADDON_PANEL_TITLE"]);

	ALSpec_Options.name = L["ADDON_PANEL_NAME"];
	InterfaceOptions_AddCategory(ALSpec_Options);
	
	-- Initialise new dropdown menu types:
	ArenaLiveOptions:AddDropDownMenuType("ALSpec_GameMode", gameModeDropDown);
	ArenaLiveOptions:AddDropDownMenuType("ALSpec_TimeLimitMinutes", timeLimitMinutesDropDown);
	ArenaLiveOptions:AddDropDownMenuType("ALSpec_TimeLimitSeconds", timeLimitSecondsDropDown);
	ArenaLiveOptions:AddDropDownMenuType("ALSpec_CountdownBroadCastChannel", broadCastChannelDropDown);
	ArenaLiveOptions:AddDropDownMenuType("ALSpec_CountdownTime", countDownTimeDropDown);
	
	-- Set Font string texts:
	ALSpec_OptionsMainTitle:SetText(L["MAIN_SETTINGS_TITLE"]);
	ALSpec_OptionsMainTimeLimitTitle:SetText(L["TIMELIMIT_TITLE"]);
	ALSpec_OptionsCountdownTitle:SetText(L["COUNTDOWN_SETTINGS_TITLE"]);
	ALSpec_OptionsScoreBoardTitle:SetText(L["SCOREBOARD_SETTINGS_TITLE"]);
	
	-- Initialise Main Options:
	ArenaLiveOptions:InitialiseDropDownMenu(ALSpec_OptionsMainGameModeDropDown, "ALSpec_GameMode", addonName, "GameMode", function() ArenaLiveSpectator:UpdateAllSideFramesVisibility(); end, nil, nil);
	UIDropDownMenu_SetWidth(ALSpec_OptionsMainGameModeDropDown, 70);
	UIDropDownMenu_JustifyText(ALSpec_OptionsMainGameModeDropDown, "CENTER");
	ArenaLiveOptions:InitialiseDropDownMenu(ALSpec_OptionsMainTimeLimitMinutesDropDown, "ALSpec_TimeLimitMinutes", addonName, "TimeLimit/Minutes", function() ALSpec_ScoreBoard:UpdateTimeLimit() end, nil, nil);
	UIDropDownMenu_SetWidth(ALSpec_OptionsMainTimeLimitMinutesDropDown, 30, 40);
	ArenaLiveOptions:InitialiseDropDownMenu(ALSpec_OptionsMainTimeLimitSecondsDropDown, "ALSpec_TimeLimitSeconds", addonName, "TimeLimit/Seconds", function() ALSpec_ScoreBoard:UpdateTimeLimit() end, nil, nil);
	UIDropDownMenu_SetWidth(ALSpec_OptionsMainTimeLimitSecondsDropDown, 30, 40);
	ArenaLiveOptions:InitialiseSlider(ALSpec_OptionsMainScaleSlider, addonName, "Scale", nil, function() local scale = ArenaLiveCore:GetDBEntry(addonName, "Scale") / 100; ArenaLiveSpectator:SetScale(scale); end, L["SCALE_SLIDER_TITLE"]);
	ArenaLiveOptions:InitialiseCheckButton(ALSpec_OptionsMainDisableQueueCheckButton, addonName, "DisableQueueButton", nil, nil, L["DISABLE_JOIN_QUEUE_BUTTON_TITLE"]);
	
	-- Initialise Countdown Options:
	ArenaLiveOptions:InitialiseCheckButton(ALSpec_OptionsCountdownBroadCastCheckButton, addonName, "Countdown/Broadcast", nil, function() ALSpec_CountDown:UpdateVariables(); ALSpec_ScoreBoard:UpdateTimeLimit() end, L["COUNTDOWN_BROADCAST_CHECKBUTTON_TEXT"]);
	ArenaLiveOptions:InitialiseDropDownMenu(ALSpec_OptionsCountdownBroadCastChannelDropDown, "ALSpec_CountdownBroadCastChannel", addonName, "Countdown/BroadcastChannel", function() ALSpec_CountDown:UpdateVariables(); ALSpec_ScoreBoard:UpdateTimeLimit() end, nil, nil);
	ArenaLiveOptions:InitialiseDropDownMenu(ALSpec_OptionsCountdownTimeDropDown, "ALSpec_CountdownTime", addonName, "Countdown/Time", function() ALSpec_CountDown:UpdateVariables() end, nil, nil);
	
	-- Initialise Scoreboard Options:
	ArenaLiveOptions:InitialiseCheckButton(ALSpec_OptionsScoreBoardShowCheckButton, addonName, "Scoreboard/Show", nil, nil, L["SCOREBOARD_SHOW_CHECKBUTTON_TEXT"]);
	ArenaLiveOptions:InitialiseEditBox(ALSpec_OptionsScoreBoardTournamentIconEditBox, addonName, "Scoreboard/TournamentIcon", nil, function() ALSpec_ScoreBoard:UpdateTournamentIcon() end, L["SCOREBOARD_TOURNAMENT_ICON_EDITBOX_TEXT"]);
	
	-- Initialise UnitFrame Options:
	ALSpec_OptionsUnitFrames:Initialise();
	
	-- Initialise Team Cache Options:
	ALSpec_OptionsTeamCache:Initialise();
	
	-- Initialise Name Alias Options:
	ALSpec_OptionsNameAliases:Initialise();
	
end